% Create a linear model of the process

m1 = 2.29; m2 = 2.044;                 % masses
d1 = 3.12; d2 = 3.73;                  % damping constants
k = 400;                               % spring constant
km = 2.96;                             % motor constant
ky = 280;                              % measurement constant

A = [0 1 0 0; -k/m1 -d1/m1 k/m1 0; 0 0 0 1; k/m2 0 -k/m2 -d2/m2];
B = [0; km/m1; 0; 0];
C = [0 0 ky 0];
D = 0;

Gp = ss(A,B,C,D);                      % create a state space model of the process

frictionoffset = 0.2;
frictiongain = 0.5;
noisepower = 5e-10;
noisesampletime = 0.01;
sinamp = 2e-5;
motortimeconst = 0.02;