% Design of state feedback

omegaa = ...;                          % speed of one pole pair
zetaa =  ...;                          % damping of one pole pair
omegab = ...;                          % speed of the other pole pair
zetab =  ...;                          % damping of the other pole pair

pc = conv([1 2*omegaa*zetaa omegaa^2],[1 2*omegab*zetab omegab^2]);
poles1 = roots(pc);

L  = place(A,B,poles1);                % compute the state feedback vector L
lr = 1/(C*inv(-A+B*L)*B);              % compute lr such that the static gain
                                       % from r->y becomes 1
% Design of observer

omegac = ...;                          % speed of one pole pair
zetac =  ...;                          % damping of one pole pair
omegad = ...;                          % speed of the other pole pair
zetad =  ...;                          % damping of the other pole pair

po = conv([1 2*omegac*zetac omegac^2],[1 2*omegad*zetad omegad^2]);
poles2 = roots(po);

K = place(A',C',poles2)';              % compute the Kalman filter gain K

% Computation of controller (observer + state feedback)

AR = A-B*L-K*C;
BRy = K;
BRr = B*lr;
CR = -L;
DRy = 0;
DRr = lr;

Gr = -ss(AR, BRy, CR, DRy);            % transfer function from -y to u
