% Design of state feedback with integral action

Ae = [A zeros(4,1); -C 0];             % A-matrix for the extended system
Be = [B; 0];                           % B-matrix for the extended system

omegaa = ...;                          % speed of one pole pair
zetaa =  ...;                          % damping of one pole pair
omegab = ...;                          % speed of the other pole pair
zetab =  ...;                          % damping of the other pole pair
omegae = ...;                          % speed of the fifth pole

pc = conv([1 2*omegaa*zetaa omegaa^2],[1 2*omegab*zetab omegab^2]);
pc = conv(pc, [1 omegae]);
poles1 = roots(pc);

Le  = place(Ae,Be,poles1);             % compute the state feedback vector Le
L = Le(1:4);
li = Le(5);
lr = 0;                                % direct term from reference value

% Design of observer

omegac = ...;                          % speed of one pole pair
zetac =  ...;                          % damping of one pole pair
omegad = ...;                          % speed of the other pole pair
zetad =  ...;                          % damping of the other pole pair

po = conv([1 2*omegac*zetac omegac^2],[1 2*omegad*zetad omegad^2]);
poles2 = roots(po);

K = place(A',C',poles2)';              % compute the Kalman gain K

% Computation of controller (observer + state feedback with integral action)

AR = [A-B*L-K*C -B*li; zeros(1,4) 0];
BRy = [K; -1];
BRr = [B*lr; 1];
CR = [-L -li];
DRy = 0;
DRr = lr;

Gr = -ss(AR,BRy,CR,DRy);               % transfer function from -y to u
